﻿$SourceDatabase = 'AdventureWorks2016' #where we take the data and build script from 
$SourceServerName = 'PentlowMillServ'
$SourceLogin = 'PhilFactor' #Leave blank for Windows authentication

#none of our errors are recoverable
$ErrorActionPreference = "Stop"
$MS = 'Microsoft.SQLServer'
#create a connection object as we can reuse this for all the operations
# is this Windows Authentication or UserID/Password credentials?
$connection = New-Object -TypeName System.Data.SqlClient.SqlConnection
$connectionString = "Server=$SourceServerName;Database=$SourceDatabase;Integrated Security=True;"
if ($SourceLogin -ne '') #if no login specified, then it was a windows login
{
	$connectionString = "Server=$SourceServerName;Database=$SourceDatabase;Integrated Security=False;"
	if (Test-Path -path "$env:USERPROFILE\$SourceLogin-$SourceServerName.txt" -PathType leaf)
	{
		#has already got this set for this login so fetch it
		$encrypted = Get-Content "$env:USERPROFILE\$SourceLogin-$SourceServerName.txt" | ConvertTo-SecureString
		$encrypted.MakeReadOnly()
		$Credentials = New-Object System.Data.SqlClient.SqlCredential($SourceLogin, $encrypted)
	}
	else
	{
		#hasn't got this set for this login
		$AutomationCredentials = get-credential -Credential $SourceLogin
		$AutomationCredentials.Password | ConvertFrom-SecureString | Set-Content  "$env:USERPROFILE\$SourceLogin-$SourceServerName.txt"
		($password = $AutomationCredentials.Password).MakeReadOnly()
		$Credentials = New-Object System.Data.SqlClient.SqlCredential(($AutomationCredentials.UserName -replace '^.*\\|@.*$'), $password)
	}
}
$connection.Credential = $Credentials
$connection.ConnectionString = $connectionString
$connection.Open() | out-null
$handler = [System.Data.SqlClient.SqlInfoMessageEventHandler] { param ($sender,
		$event)    $global:message = "$($message)`n $($event.Message)" };
$connection.add_InfoMessage($handler);
$connection.FireInfoMessageEventOnUserErrors = $true

do
{
	@(1 ..20777) | foreach{
		$cmd = new-Object System.Data.SqlClient.SqlCommand(@'
SELECT Person.FirstName + ' ' + Person.LastName AS Name,
  Address.AddressLine1 + ', ' + Coalesce(Address.AddressLine2 + ', ', '')
  + Address.City + ' ' + Address.PostalCode AS address
  FROM Person.Person
    INNER JOIN Person.BusinessEntityAddress
      ON BusinessEntityAddress.BusinessEntityID = Person.BusinessEntityID
    INNER JOIN Person.Address
      ON Address.AddressID = BusinessEntityAddress.AddressID
  WHERE Person.BusinessEntityID =  @beid
'@, $connection)
		$cmd.Parameters.Add("@beid", [system.data.SqlDbType]::Int) | out-Null
		$cmd.Parameters['@beid'].value = $_
		Start-Sleep -seconds (get-random -maximum 10 -minimum 1)
		$rdr = $cmd.ExecuteReader() #because we are getting a result back
		do
		{
			$datatable = new-object System.Data.DataTable
			$datatable.Load($rdr)
			$datatable | Format-table
		}
		while ($rdr.IsClosed -eq $false)
		$rdr.Close()
	}
}
While ($true -eq $true)